100  REMark *******************************
110  REMark *        Q S T A R 2          *
120  REMark *                             *
130  REMark *        version 1.0          *
140  REMark *    code date 2024.05.10     *
150  REMark *                             *
160  REMark *        Andrei Tenu          *
170  REMark *******************************
180  TURBO_windo 3
190  TURBO_model 1
200  TURBO_diags 0
210  TURBO_objdat 10
220  TURBO_objstk 350
230  TURBO_taskn "QStar 2"
240  REMark %%win1_Dev_QStar_movemem_cde,0,12
250  REMark %%win1_Dev_QStar_timing_cde,0,10
260  DIM Dev$(32)
270  Dev$=OPTION_CMD$
280  IF Dev$="" THEN Dev$='flp1_'
290  MODE 8:CLS
300  T_ON:Init
310  Level=1
320  ShowLevel Level
330  REPeat MainLoop
340   mc=CODE(INKEY$(-1))
350   SELect ON mc
360     =192: MoveLeft
370     =200: MoveRight
380     =208: MoveUp
390     =216: MoveDown
400     =32 : SwapHeroCrate
410     =83, 115: IF lng$=1 THEN SelectLevel: ELSE QuitGame
420     =82, 114: RestartLevel
430     =81, 113: IF lng$=1 THEN QuitGame
440     =232: SetDelay
450     =236: SoundOn=NOT SoundOn: CURSOR#ch,252-(lng$=2)*16,20: OVER#ch, -1:INK#ch,7:PRINT#ch,'%';:OVER#ch,0
455     =240: ShowSolution
460     =65,97: AboutBox
470     =69, 101: IF lng$=2 THEN SelectLevel
480   END SELect
490   IF Gems<1 THEN LevelCompleted
500   IF moves>250 THEN LostLevel
510  END REPeat MainLoop
1000 REMark --------------------------------------
1010 DEFine PROCedure Init
1020 LOCal a$(1), b$(130)
1030   REMark Define some global variables
1040   DIM GridX(15): DIM GridY(9): DIM ds(10): DIM lng$(1):ch=3:ch1=4:ch2=5:ADelay=0:SoundOn=1:isQDOS=(VER$<>"HBA"):bkg=0
1050   OPEN#ch, con_:OPEN#ch2,scr_
1060   WINDOW#ch,512,256,0,0: BORDER#ch,0,0:PAPER#ch,5,4,3: INK#ch,1: CLS#ch
1070   TestDir
1080   LBYTES Dev$&'init_dat',131072
1090   lng$=INKEY$(-1)
1100   IF NOT lng$ INSTR "12" THEN GO TO 1090
1110   CLS#ch:LBYTES Dev$&'title_dat', 132480-(4+isQDOS)*128
1120   fnt1=ALCHP(1452):lvl=ALCHP(950)
1130   sp=ALCHP(5304)
1140   LBYTES Dev$&'bold_fnt',fnt1
1150   LBYTES Dev$&'sprites_dat',sp
1160   LBYTES Dev$&'levels_dat',lvl
1170   WINDOW#ch,480,195,16,49
1180   CHAR_USE#ch, fnt1,0:CHAR_USE#ch2, fnt1,0
1190   IF lng$=1 THEN RESTORE 9030: ELSE RESTORE 9150: END IF
1200   READ b$
1210   AT#ch,0,0: INK#ch,0:PRINT#ch, b$;
1220   READ b$: PRINT#ch,b$
1230   PrecalcData
1240   READ b$: AT#ch,7,0: PrintRed b$,2:READ b$: PRINT#ch,b$
1250   PutSprite 131072+14216+20*128,HeroSp,8
1260   READ b$: AT#ch,11,0: PrintRed b$,2:READ b$: PRINT#ch,b$
1270   PutSprite 131072+14216+60*128,CrateSp,8
1280   READ b$: AT#ch,15,0: PRINT#ch,b$;:READ b$: PrintRed b$,3:READ b$: PRINT#ch,b$
1290   READ b$: AT#ch,16,0 :PRINT#ch,b$;:READ b$: PrintRed b$,3:READ b$: PRINT#ch,b$
1300   READ b$: AT#ch,18,1: PrintRed b$,2
1310   DefineLngArrays: ReadSolutions
1320   a$=INKEY$(-1)
1330   CLS#ch
1340   OPEN#ch1,scr_
1350   WINDOW#ch1, 384,162,64,42: PAPER#ch1,4: CLS#ch1
1360   InfoWindow ch, 481,38,16,213,205
1370   WriteInfo
1380 END DEFine Init
1390 REMark --------------------------------------
1400 DEFine PROCedure PrintRed (a$,x)
1410   INK#ch,x:PRINT#ch,a$;:INK#ch,1:
1420 END DEFine PrintRed
1430 REMark --------------------------------------
1440 DEFine PROCedure TestDir
1450 LOCal a$(1)
1460   IF (FTEST(Dev$&'title_dat')<0 OR FTEST(Dev$&'init_dat') OR FTEST(Dev$&'bold_fnt') OR FTEST(Dev$&'sprites_dat') OR FTEST(Dev$&'levels_dat'))THEN
1470     INK#ch,1:PRINT#ch, 'Cannot find files.':PRINT#ch, 'Please configure program!'
1480     PRINT#ch, 'Archivo no encontrado.':PRINT#ch, 'Por favor, configura el programa!'
1490     PRINT#ch, 'E.g.':PRINT#ch,'EXEC_W win1_QSTAR_QSTAR_exe;"win1_QSTAR_"'
1500     CLOSE#ch:CLOSE#ch2:BEEP 10000,250:T_OFF
1510     a$=INKEY$(-1)
1520     STOP
1530   END IF
1540 END DEFine TestDir
1550 REMark --------------------------------------
1560 DEFine PROCedure PrecalcData
1570 LOCal i,j,ch
1580 CrateX=0:CrateY=0:CrateAddr=0:HeroX=0:HeroY=0: Gems=0
1590 DIM Board(8,15): DIM Screen(8,15)
1600 WallSp=sp: GemSp=sp+144: CrateSp=sp+288:HeroSp=sp+3168:HeroSp1= sp+4320: Fsp=sp+4464: JoySp=sp+4704:moves=0:TornadoSp=sp+432:KeySp=sp+4944
1610 DIM Best(9)
1620 ch=FOP_IN(Dev$&'Best_dat')
1630 IF ch>0 THEN
1640   FOR i=0 TO 9:INPUT#ch,Best(i):END FOR i
1650    INPUT#ch,ADelay
1660   CLOSE#ch
1670 ELSE
1680   FOR i=0 TO 9:Best(i)=250:END FOR i
1690 END IF
1700 FOR i=0 TO 8
1710   FOR j=0 TO 15
1720     Screen(i,j)=131072+42*128+i*18*128+j*8
1730   END FOR j
1740 END FOR i
1750 REMark matrices for sprite movement Right, Left, Up, Down
1760 DIM SprR(3): DIM SprL(3): DIM SprU(3): DIM SprD(3):
1770 FOR i=0 TO 3
1780   SprR(i)=sp+1728+i*180
1800   SprL(i)=sp+1728+4*180+i*180
1820   SprD(i)=sp+1728+8*180+i*144
1840   SprU(i)=sp+1728+8*180+4*144+i*144
1860 END FOR i
1870 END DEFine PrecalcData
1880 REMark --------------------------------------
1890 DEFine PROCedure PutSprite (locaddr,spaddr, wd)
1900 REMark wd width is in bytes ht is in pixels
1910 LOCal addrsp, addr
1920 addrsp=spaddr:addr=locaddr
1930 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
1940 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
1950 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
1960 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
1970 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
1980 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
1990 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2000 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2010 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2020 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2030 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2040 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2050 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2060 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2070 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2080 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2090 MOVE_MEMORY addrsp TO addr,wd:addrsp=addrsp+wd: addr=addr+128
2100 MOVE_MEMORY addrsp TO addr,wd
2110 IF ADelay THEN Delay ADelay
2120 END DEFine PutSprite
2130 REMark --------------------------------------
2140 DEFine PROCedure ShowLevel(k)
2150 LOCal x, x1, addr, i, j
2160   CLS#ch1: Gems=0:moves=0
2170   addr=lvl+38*(k-1)
2180   x=PEEK(addr):HeroX=x DIV 16: HeroY=x MOD 16
2190   x=PEEK(addr+1):CrateX=x DIV 16: CrateY=x MOD 16
2200   FOR i=0 TO 8
2210     FOR j=0 TO 3
2220       x=PEEK(addr+2+i*4+j)
2230       x1=(x&&192)DIV 64: SelectTile i, j*4, x1
2240       x1=(x&&48)DIV 16: SelectTile  i, j*4+1, x1
2250       x1=(x&&14)DIV 4:SelectTile  i, j*4+2, x1
2260       x1=(x&&3): SelectTile i, j*4+3,x1
2270     END FOR j
2280   END FOR i
2290   PutSprite Screen(HeroX,HeroY),HeroSp,8:Board(HeroX,HeroY)=3
2300   PutSprite Screen(CrateX,CrateY),CrateSp,8:Board(CrateX,CrateY)=4
2310   WriteLevel k
2320   Writebest Best(k-1)
2330   WriteMoves moves
2350   REMark PutSprite 131072+(226+isQDOS)*128+12,HeroSp1,8
2360 END DEFine ShowLevel
2380 DEFine PROCedure SelectTile(i,j,x1)
2390   Board(i,j)=x1
2400   SELect ON x1
2410     =1:PutSprite Screen(i,j),WallSp,8
2420     =2:PutSprite Screen(i,j), GemSp,8: Gems=Gems+1
2430   END SELect
2440 END DEFine SelectTile
2450 REMark --------------------------------------
2460 DEFine PROCedure SwapHeroCrate
2470 LOCal x,Y,i%, addr,XDelay
2471   x=HeroX:Y=HeroY:HeroX=CrateX:HeroY=CrateY: CrateX=x:CrateY=Y:addr=TornadoSp:XDelay=ADelay:ADelay=2
2473   FOR i%=0 TO 8
2474     PutSprite Screen(HeroX,HeroY),addr,8
2475     PutSprite Screen(CrateX,CrateY),addr,8:addr=addr+144
2476   END FOR i%
2477   ADelay=XDelay
2478   PutSprite Screen(HeroX,HeroY),HeroSp,8:Board(HeroX,HeroY)=3
2479   PutSprite Screen(CrateX,CrateY),CrateSp,8:Board(CrateX,CrateY)=4
2490 END DEFine SwapHeroCrate
2500 REMark --------------------------------------
2510 DEFine PROCedure MoveRight
2520 LOCal i,j,nx,ny, locaddr, CanMove,IncMoves
2530   CanMove=1:IncMoves=0
2540   REPeat loop
2550     PickGem=0
2620     nx=HeroX:ny=HeroY+1
2630     IF nx>15 OR (Board(nx,ny)>0 AND Board(nx,ny)<>2) THEN CanMove=0: EXIT loop
2640     IF Board(nx,ny)=2 THEN : Board(nx,ny)=0:Gems=Gems-1: PickGem=1:END IF
2650     locaddr=Screen(HeroX,HeroY)
2660     Board(HeroX,HeroY)=0:Board(nx,ny)=3:HeroX=nx:HeroY=ny
2680     FOR i=0 TO 3
2690       PutSprite locaddr,SprR(0), 10
2700       PutSprite locaddr,SprR(1), 10
2710       PutSprite locaddr,SprR(2), 10
2720       PutSprite locaddr,SprR(3), 10
2730       locaddr=locaddr+2
2740     END FOR i
2750     IncMoves=1
2760     IF PickGem AND SoundOn THEN BEEP 5000, 6, 49,409, -4, 5,6,2
2770     IF NOT CanMove THEN EXIT loop
2780   END REPeat loop
2790   IF locaddr>0 : PutSprite locaddr,HeroSp,8
2800   IF IncMoves=1 THEN moves=moves+1: WriteMoves moves
2810 END DEFine MoveRight
2820 REMark --------------------------------------
2830 DEFine PROCedure MoveLeft
2840 LOCal i,j,nx,ny, locaddr,CanMove, IncMoves
2850   CanMove=1: IncMoves=0
2860   REPeat loop
2870     PickGem=0
2940     nx=HeroX:ny=HeroY-1
2950     IF nx<0 OR (Board(nx,ny)>0 AND Board(nx,ny)<>2) THEN CanMove=0: EXIT loop
2960     IF Board(nx,ny)=2 THEN : Board(nx,ny)=0:Gems=Gems-1: PickGem=1:END IF
2970     locaddr=Screen(HeroX,HeroY)-2
2980     Board(HeroX,HeroY)=0:Board(nx,ny)=3:HeroX=nx:HeroY=ny
3000     FOR i=0 TO 3
3010       PutSprite locaddr,SprL(0), 10
3020       PutSprite locaddr,SprL(1), 10
3030       PutSprite locaddr,SprL(2), 10
3040       PutSprite locaddr,SprL(3), 10
3050       locaddr=locaddr-2
3060     END FOR i
3070     IncMoves=1
3080     IF PickGem AND SoundOn THEN BEEP 5000, 6, 49,409, -4, 5,6,2
3090     IF NOT CanMove THEN EXIT loop
3100   END REPeat loop
3110   IF locaddr>0 : PutSprite locaddr+2,HeroSp,8
3120   IF IncMoves=1 THEN moves=moves+1: WriteMoves moves
3130 END DEFine MoveLeft
3140 REMark --------------------------------------
3150 DEFine PROCedure MoveUp
3160 LOCal i,j,nx,ny,locaddr, CanMove, IncMoves
3170   CanMove=1:IncMoves=0
3180   REPeat loop
3190     PickGem=0
3260     nx=HeroX-1:ny=HeroY:PickGem=0
3270     IF nx<0 OR (Board(nx,ny)>0 AND Board(nx,ny)<>2) THEN CanMove=0: EXIT loop
3280     IF Board(nx,ny)=2 THEN : Board(nx,ny)=0:Gems=Gems-1: PickGem=1:END IF
3290     locaddr=Screen(HeroX,HeroY)
3300     Board(HeroX,HeroY)=0:Board(nx,ny)=3:HeroX=nx:HeroY=ny
3320     FOR i=0 TO 3
3330       locaddr=locaddr-128
3340       PutSprite locaddr,SprU(0), 8
3350       locaddr=locaddr-128
3360       PutSprite locaddr,SprU(1), 8
3370       locaddr=locaddr-128
3380       PutSprite locaddr,SprU(2), 8
3390       locaddr=locaddr-128
3400       PutSprite locaddr,SprU(3), 8
3410     END FOR i
3420     locaddr=locaddr-128
3430     PutSprite locaddr,SprU(0), 8
3440     locaddr=locaddr-128
3450     PutSprite locaddr,SprU(1), 8
3460     IF PickGem AND SoundOn THEN BEEP 5000, 6, 49,409, -4, 5,6,2
3470     IncMoves=1
3480     IF NOT CanMove THEN EXIT loop
3490   END REPeat loop
3500   IF locaddr>0 THEN PutSprite locaddr,HeroSp,8
3510   IF IncMoves=1 THEN moves=moves+1: WriteMoves moves
3520 END DEFine MoveUp
3530 REMark --------------------------------------
3540 DEFine PROCedure MoveDown
3550 LOCal i,j,nx,ny, locaddr, CanMove,IncMoves
3560   CanMove=1:IncMoves=0:PickGem=0
3570   REPeat loop
3580     PickGem=0
3650     nx=HeroX+1:ny=HeroY
3660     IF nx>8 OR (Board(nx,ny)>0 AND Board(nx,ny)<>2) THEN CanMove=0: EXIT loop
3670     IF Board(nx,ny)=2 THEN : Board(nx,ny)=0:Gems=Gems-1: PickGem=1:END IF
3680     locaddr=Screen(HeroX,HeroY)
3690     Board(HeroX,HeroY)=0:Board(nx,ny)=3:HeroX=nx:HeroY=ny
3710     FOR i=0 TO 3
3720       locaddr=locaddr+128
3730       PutSprite locaddr,SprD(0), 8
3740       locaddr=locaddr+128
3750       PutSprite locaddr,SprD(1), 8
3760       locaddr=locaddr+128
3770       PutSprite locaddr,SprD(2), 8
3780       locaddr=locaddr+128
3790       PutSprite locaddr,SprD(3), 8
3800     END FOR i
3810     locaddr=locaddr+128
3820     PutSprite locaddr,SprD(0), 8
3830     locaddr=locaddr+128
3840     PutSprite locaddr,SprD(1), 8
3850     IncMoves=1
3860     IF PickGem AND SoundOn THEN BEEP 5000, 6, 49,409, -4, 5,6,2
3870     IF NOT CanMove THEN EXIT loop
3880   END REPeat loop
3890   IF locaddr>0 THEN PutSprite locaddr,HeroSp,8
3900   IF IncMoves=1 THEN moves=moves+1: WriteMoves moves
3910 END DEFine MoveDown
3920 REMark --------------------------------------
3930 DEFine PROCedure InfoWindow (ch,w,h,x,Y,ppr)
3940   WINDOW#ch, w,h,x,Y: PAPER#ch,ppr:BORDER#ch,1,0:CLS#ch
3950   WINDOW#ch, w-4,h-2,x+2,Y+1: BORDER#ch,2,2
3960   DrawCorners w,h,x,Y: REMark 481,37,16,213
3970   WINDOW#ch, w-21,h-6,x+10,Y+3:CLS#ch
3980 END DEFine InfoWindow
3990 REMark --------------------------------------
4000 DEFine PROCedure SelectLevel
4010 LOCal x,ax
4020   SaveBkg
4030   InfoWindow ch2, 280,50,113,100,6: INK#ch2,1
4040   x=Level
4050   AT#ch2,1,1:PRINT#ch2, Menu$($2)&' (1-10)'
4060   AT#ch2,2,1:PRINT#ch2, '      <- ';x;' ->'
4070   REPeat loop
4080     ax=CODE(INKEY$(-1))
4090     SELect ON ax
4100       =192: x=x-(x>1): AT#ch2,2,1:PRINT#ch2, '      <- ';x;' -> '
4110       =200: x=x+(x<10): AT#ch2,2,1:PRINT#ch2, '      <- ';x;' -> '
4120       =10: Level=x: EXIT loop
4130       =27: Redobkg: EXIT loop
4140     END SELect
4150   END REPeat loop
4160   IF ax=10 THEN RECHP bkg: ShowLevel Level: END IF
4170 END DEFine SelectLevel
4180 REMark --------------------------------------
4190 DEFine PROCedure LevelCompleted
4200 LOCal a$(1)
4210   InfoWindow ch2, 280,50,113,100,6: INK#ch2,1
4220   AT#ch2,1,1:PRINT#ch2, Menu$(12)
4230   AT#ch2,2,1:PRINT#ch2, Menu$(13);moves;Menu$(14)
4240   IF moves<Best(Level-1) THEN Best(Level-1)=moves
4250   IF SoundOn THEN BEEP 32000,0,20,5000,200
4260   a$=INKEY$(-1)
4270   Level=Level+(Level<25)
4280   ShowLevel Level
4290 END DEFine LevelCompleted
4300 REMark --------------------------------------
4310 DEFine PROCedure QuitGame
4320 LOCal a$(1)
4330   SaveBkg
4340   InfoWindow ch2, 280,50,113,100,6: INK#ch2,1
4350   AT#ch2,1,1:PRINT#ch2, Menu$(11)
4360   AT#ch2,2,8:PRINT#ch2, YN$(0)
4370   a$=INKEY$(-1)
4380   IF NOT(a$ INSTR YN$(1)) THEN GO TO 4370
4390   IF a$ INSTR "YySs" THEN ClosePrg
4400   Redobkg
4410 END DEFine QuitGame
4420 REMark --------------------------------------
4430 DEFine PROCedure SaveBkg
4440   bkg=ALCHP(50*128)
4450   MOVE_MEMORY 131072+12800 TO bkg, 50*128
4460 END DEFine SaveBkg
4470 REMark --------------------------------------
4480 DEFine PROCedure Redobkg
4490   MOVE_MEMORY bkg TO 131072+12800, 50*128
4500   RECHP bkg: bkg=0
4510 END DEFine Redobkg
4520 REMark --------------------------------------
4530 DEFine PROCedure RestartLevel
4540 LOCal a$(1)
4550   SaveBkg
4560   InfoWindow ch2, 280,50,113,100,6: INK#ch2,1
4570   AT#ch2,1,1:PRINT#ch2, Menu$(10)
4580   AT#ch2,2,8:PRINT#ch2, YN$(0)
4590   a$=INKEY$(-1)
4600   IF NOT(a$ INSTR YN$(1)) THEN GO TO 4590
4610   IF a$ INSTR "YySs" THEN RECHP bkg: ShowLevel Level:ELSE Redobkg:END IF
4620 END DEFine RestartLevel
4630 REMark --------------------------------------
4640 DEFine PROCedure SetDelay
4650 LOCal x,ax
4660   SaveBkg
4670   InfoWindow ch2, 280,50,113,100,6: INK#ch2,1
4680   x=ADelay
4690   AT#ch2,1,1:PRINT#ch2, Menu$(9)
4700   AT#ch2,2,1:PRINT#ch2, '      <- ';x;' ->'
4710   REPeat loop
4720     ax=CODE(INKEY$(-1))
4730     SELect ON ax
4740       =192: x=x-(x>0): AT#ch2,2,1:PRINT#ch2, '      <- ';x;' -> '
4750       =200: x=x+(x<25): AT#ch2,2,1:PRINT#ch2, '      <- ';x;' -> '
4760       =10: EXIT loop
4770       =27: EXIT loop
4780     END SELect
4790   END REPeat loop
4800   Redobkg
4810   IF ax=10 THEN ADelay=x: END IF
4820 END DEFine SetDelay
4830 REMark --------------------------------------
4840 DEFine PROCedure LostLevel
4850 LOCal a$
4860   InfoWindow ch2, 280,50,113,100,6: INK#ch2,1
4870   AT#ch2,1,1:PRINT#ch2, Menu$(7)
4880   AT#ch2,2,1:PRINT#ch2, Menu$(8)
4890   a$=INKEY$(-1)
4900   IF SoundOn THEN BEEP 32000,500,20,5000,200
4910   ShowLevel Level
4920 END DEFine LostLevel
4930 REMark --------------------------------------
4940 DEFine PROCedure AboutBox
4950 LOCal a$(1)
4960   SaveBkg
4970   InfoWindow ch2, 280,50,113,100,6: INK#ch2,1
4980   AT#ch2,1,1:PRINT#ch2, '   QStar2 - v1.0'
4990   AT#ch2,2,1:PRINT#ch2, ' Andrei Tenu  2024'
5000   a$=INKEY$(-1)
5010   Redobkg
5020 END DEFine AboutBox
5030 REMark --------------------------------------
5040 DEFine PROCedure ClosePrg
5050   LOCal cch
5060   RECHP fnt1: RECHP sp: RECHP lvl:T_OFF
5070   IF bkg>0 THEN RECHP bkg
5080   cch=FOP_OVER(Dev$&'Best_dat')
5090   IF cch>0 THEN
5100     FOR i=0 TO 9:PRINT#cch,Best(i):END FOR i:
5110     PRINT#cch,ADelay:CLOSE#cch
5120   END IF
5125   WINDOW#ch,512,256,0,0:PAPER#ch,0:INK#ch,7:CLS#ch
5130   CLOSE#ch:CLOSE#ch1:CLOSE#ch2
5135   MODE 4
5140   STOP
5150 END DEFine ClosePrg
5160 REMark --------------------------------------
5170 DEFine PROCedure WriteInfo
5180   CHAR_USE#ch, fnt1,0
5190   INK#ch,1:PutBigSprite 131072+216*128+64+(lng$=1)*4,Fsp,8
5200   PutBigSprite 131072+(216+isQDOS)*128+8,KeySp,12:PutBigSprite 131072+(216+isQDOS)*128+20,JoySp,8
5210   WriteLevel 1
5220   CreateMoves:WriteMoves 0
5230   Writebest 500
5240   WriteMenu 0,25-2*(lng$-1),Menu$(1)
5250   WriteMenu 1,25-2*(lng$-1),Menu$(2)
5260   WriteMenu 2,25-2*(lng$-1),Menu$(3)
5270 END DEFine WriteInfo
5280 REMark --------------------------------------
5290 DEFine PROCedure WriteMenu (x,Y,a$)
5300   AT#ch,x,Y:INK#ch, 2: PRINT#ch, a$(1);: INK#ch,1:PRINT#ch, a$(2 TO LEN(a$));
5310 END DEFine WriteMenu
5320 REMark --------------------------------------
5330 DEFine PROCedure WriteLevel (x)
5340 LOCal a$(3)
5350   a$=x
5360   IF x<10 THEN a$='0'&a$
5370   AT#ch,0,9-(lng$=2): INK#ch,1: PRINT#ch, Menu$(4);:INK#ch,2:PRINT#ch,a$
5380 END DEFine WriteLevel
5390 REMark --------------------------------------
5400 DEFine PROCedure WriteMoves (x)
5410   AT#ch,1,15-(lng$=2):STRIP#ch,0:INK#ch,7:PRINT_USING#ch,"###",x:STRIP#ch,5,4,3
5420 END DEFine WriteMoves
5430 REMark --------------------------------------
5440 DEFine PROCedure Writebest (x)
5450   AT#ch,2,9-(lng$=2): INK#ch,1: PRINT#ch, Menu$(5);:INK#ch,4:PRINT#ch,"    ";
5460   AT#ch,2,15-(lng$=2): INK#ch,2:PRINT#ch,x;
5470 END DEFine Writebest
5480 REMark --------------------------------------
5490 DEFine PROCedure CreateMoves
5500   BLOCK#ch, 41,10,176-(lng$=2)*7,10,0
5510   AT#ch,1,9-(lng$=2) : INK#ch,1: PRINT#ch, Menu$(6)
5520 END DEFine CreateMoves
5530 REMark --------------------------------------
5540 DEFine PROCedure DrawCorners(w,h,x,Y)
5550 LOCal i,x1,y1, xx
5560   xx=x DIV 4:xxx=(w+x) DIV 4
5570   RESTORE 9000
5580   FOR i=0 TO 5
5590    READ x1,y1:POKE_W 131072+Y*128+xx+i*128,x1:POKE_W 131072+Y*128+xx+2+i*128,y1
5600    POKE_W 131072+(h+Y-1)*128+xx-i*128,x1:POKE_W 131072+(h+Y-1)*128+xx+2-i*128,y1
5610   END FOR i
5620   FOR i=0 TO 5
5630    READ x1,y1:POKE_W 131072+Y*128+xxx-4+i*128,x1:POKE_W 131072+Y*128+xxx-4+2+i*128,y1
5640    POKE_W 131072+(h+Y-1)*128+xxx-4-i*128,x1:POKE_W 131072+(h+Y-1)*128+xxx-4+2-i*128,y1
5650   END FOR i
5660 END DEFine DrawCorners
5670 REMark --------------------------------------
5680 DEFine PROCedure Delay(ms)
5690 LOCal t
5700   T_START 1
5710   REPeat l
5720     IF T_COUNT(1)>=ms THEN T_STOP 1: EXIT l
5730   END REPeat l
5740 END DEFine Delay
5750 REMark --------------------------------------
5760 DEFine PROCedure DefineLngArrays
5770 LOCal i%
5780 DIM Menu$(15, 22): DIM YN$(1,5)
5790   FOR i%=0 TO 15: READ Menu$(i%): END FOR i%
5800   READ YN$(0): READ YN$(1)
5810 END DEFine DefineLngArrays
5820 REMark --------------------------------------
5830 DEFine PROCedure PutBigSprite (locaddr,spaddr,nobytes)
5840 REMark Puts a sprite 16x230 pixels
5850 LOCal addrsp, addr, i%
5860 addrsp=spaddr:addr=locaddr
5870 FOR i%=0 TO 29
5880   MOVE_MEMORY addrsp TO addr,nobytes:addrsp=addrsp+nobytes: addr=addr+128
5890 END FOR i%
5900 END DEFine PutBigSprite
5910 REMark --------------------------------------
5920 DEFine PROCedure ReadSolutions
5930 Local i%
5940   DIM Solution$(9,57)
5950   RESTORE 9270
5960   for i%=0 to 9: Read Solution$(i%): end for i%
5970 END DEFine ReadSolutions
5980 REMark --------------------------------------
5990 DEFine PROCedure ShowSolution
6000 LOCal a$(1), i%, x
6010   SaveBkg
6020   InfoWindow ch2, 280,50,113,100,6: INK#ch2,1
6030   AT#ch2,1,1:PRINT#ch2, Menu$(15)
6040   AT#ch2,2,8:PRINT#ch2, YN$(0)
6050   a$=INKEY$(-1)
6060   IF NOT(a$ INSTR YN$(1)) THEN GO TO 4370
6070   Redobkg
6080   IF a$ INSTR "YySs" THEN 
6090     ShowLevel Level: pause 30
6100     for i%=1 to len(Solution$(level-1))
6120       x=code(Solution$(level-1,i%))
6130       Select on x
6140         =83:  SwapHeroCrate
6150         =76: MoveLeft
6160         =82: MoveRight
6170         =85: MoveUp
6180         =68: MoveDown
6190       end SELect
6200       Pause 30
6210     END for i%
6220     ShowLevel Level
6230   end if
6240 END DEFine ShowSolution
6250 REMark --------------------------------------  
9000 DATA -24566,128,-32728,170,160,170,128,2720,170,2720,42,2720
9010 DATA 2,2720,170,552,170,10,-24566,2,-24566,170,-24566,168
9020 REMark English texts --------------------------------------
9030 DATA "    QStar is a puzzle game not for the  faint-hearted. It will test your mental acuity as you make your way through the 10 levels. "
9040 DATA ' You have to move around and  collect all diamonds using the least    possible moves.'
9050 DATA 'Hero',' only he can collect the diamonds.       Once moving he will move until he       hits a wall or the blocker.'
9060 DATA 'Blocker'," can't move or collect diamonds.      But by magic it can switch              position with the Hero."
9070 DATA 'Use ', 'Cursor Keys',' to move the Hero'
9080 DATA 'Use ', 'Space',' to switch Hero with Blocker'
9090 DATA '     -- press any key to start --'
9100 DATA '', 'Restart level','Select level', 'Quit game', 'Level ','Best ', 'Moves'
9110 DATA ' TOO  MANY  MOVES!   ', '   RESTART LEVEL ','Set animation delay','   RESTART LEVEL?     ','     QUIT GAME?     '
9120 DATA '  LEVEL COMPLETED   ', '    in ',' moves',  '   Show solution?'
9130 DATA '(Y/N)', 'YyNn'
9140 REMark Spanish texts --------------------------------------
9150 DATA "   QStar es un juego de puzzles no apto para pusilnimes. Desafiar tu agudeza  mental a medida que avances por los 10  niveles."
9160 DATA "Debes recoger todos los diaman- tes de cada nivel haciendo el menor     nmero de movimientos posible."
9170 DATA 'Hroe',' debe recoger todos los diamantes.       Una vez se mueva, slo parar al        tocar una pared o al bloqueador.'
9180 DATA 'Bloqueador ', 'no puede moverse ni recoger        diamantes, pero por arte de magia,      puede intercambiar su posicin          con el hroe.'
9190 DATA '','Cursores',' Mover al Hroe'
9200 DATA '','Espacio','  Cambiar Hroe por Bloqueador'
9210 DATA '  -- pulsa una tecla para empezar --'
9220 DATA '', 'Reiniciar nivel', 'Elegir nivel', 'Salir', 'Nivel ', 'Mejor ', 'Movim'
9230 DATA 'DEMASIADOS MOVIMIENTOS', '  REINICIAR NIVEL ','Retraso de animacin',' Reiniciar nivel?',' Salir del juego?'
9240 DATA ' NIVEL COMPLETADO  ',' en ',' movimientos',' Mostrar solucin?'
9250 DATA '(S/N)', 'SsNn'
9260 REMark Solutions
9270 DATA 'SULDRDLDLSR'
9280 DATA 'URSRUSLUSDLSDLSUSRUSDRUSDRSDLURURULDSULDRUDLD'
9290 DATA 'URDSRURDLULUSLULURD'
9300 DATA 'RURDLDRULULURSURURDRULRDSDL'
9310 DATA 'LSUDLURLDRURUSURURDRSRDLRULSULSDLDRURULD'
9320 DATA 'SRUSRULSDLURDSDLURDRLSLRULSDLUSRDLURLDSDRULD'
9330 DATA 'RULURURURDULSURULD'
9340 DATA 'SLULDLRURSRULURDLDSLULUSUL'
9350 DATA 'SLUSURSDRSUSLSDRLUSULRURSDRUSLDRULRSLDRUL'
9360 DATA 'SLUSURSDRSUSLSDLRURLULSDLUSRDLUSURDLURLDRSURDSLURDSDLURDL'
